<?if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED !== true) die();

use Bitrix\Main\Loader,
    Bitrix\Iblock;

if (!isset($arParams["CACHE_TIME"]))
    $arParams["CACHE_TIME"] = 36000000;

$arParams["IBLOCK_TYPE"] = trim($arParams["IBLOCK_TYPE"]);
$arParams["IBLOCK_ID"] = intval($arParams["IBLOCK_ID"]);
//Поля элементов
if (!is_array($arParams["PROPERTY_CODE"]))
    $arParams["PROPERTY_CODE"] = array();
foreach ($arParams["PROPERTY_CODE"] as $key => $val)
    if ($val === "")
        unset($arParams["PROPERTY_CODE"][$key]);
$arParams["ELS_COUNT"] = intval($arParams["ELS_COUNT"]);
$arParams["PRICE_CODE"] = intval($arParams["PRICE_CODE"]);


$arResult["SECTIONS"] = array(); //Разделы


if ($this->startResultCache(false, ($arParams["CACHE_GROUPS"] === "N" ? false : $USER->GetGroups()))) {
    if (!Loader::includeModule("iblock")) {
        $this->abortResultCache();
        ShowError(GetMessage("IBLOCK_MODULE_NOT_INSTALLED"));
        return;
    }
    $existIblock = Iblock\IblockSiteTable::getList(array(
        'select' => array('IBLOCK_ID'),
        'filter' => array('=IBLOCK_ID' => $arParams['IBLOCK_ID'], '=SITE_ID' => SITE_ID, '=IBLOCK.ACTIVE' => 'Y')
    ))->fetch();
    if (empty($existIblock)) {
        $this->abortResultCache();
        return;
    }

    //ДАННЫЕ РАЗДЕЛА
    $arFilter = array(
        "ACTIVE" => "Y",
        "IBLOCK_ID" => $arParams["IBLOCK_ID"],
    );
    //Выводимые поля
    $arSelect = array();
    if (!empty($arSelect)) {
        $arSelect[] = "ID";
        $arSelect[] = "NAME";
        $arSelect[] = "IBLOCK_ID";
        $arSelect[] = "IBLOCK_SECTION_ID";
        $arSelect[] = "SECTION_PAGE_URL";
    }
    //Сортировка
    $arSort = array(
        "left_margin" => "asc", //Сортировка
    );

    //Собираем
    $rsSections = CIBlockSection::GetList($arSort, $arFilter, $arSelect);
    while ($arSection = $rsSections->GetNext()) {

        //Выбранные свойства элементов
        $propsArray[] = array();
        foreach ($arParams["PROPERTY_CODE"] as $propValue) {
            //Для сборки в кучу параметтров
            $propValue = 'PROPERTY_' . $propValue;
            $propsArray[] = $propValue;
        }

        //Отбор полей элементов
        $PriceCode = 'CATALOG_GROUP_'.$arParams["PRICE_CODE"];
        $ElementFields = Array(
            "IBLOCK_ID",
            "ID",
            $PriceCode,
            "NAME",
            "DETAIL_PAGE_URL",
            "PREVIEW_TEXT",
            'PREVIEW_PICTURE'
        );
        $ElementFieldsAll = array_merge($ElementFields,$propsArray);

        $arItems = CIBlockElement::GetList( //Получаем элементы раздела, для результата
            Array("sort" => "asc"),
            Array("IBLOCK_ID" => $arParams["IBLOCK_ID"],"SECTION_ID" => $arSection['ID']),
            false,
            Array("nPageSize" => $arParams["ELS_COUNT"]),
            $ElementFieldsAll
        );
        while ($arItem = $arItems->GetNext()) {
            $ElPicture['ELEMENT_PICTURE'] = trim(CFile::GetPath($arItem["PREVIEW_PICTURE"]));
            $Element['ELEMENT'][] = array_merge($arItem, $ElPicture);
        }
        \Bitrix\Iblock\InheritedProperty\SectionValues::queue($arSection["IBLOCK_ID"], $arSection["ID"]);
        $arResult["SECTIONS"][] = array_merge($arSection, $Element); //СОБИРАЕМ
        unset($arSection, $Element);
    }

    $this->setResultCacheKeys(array(
        "SECTION",
    ));
    $this->includeComponentTemplate();
}
